%define	major	1

#the old name was _libelfutils1
%define	libname	%mklibname %{name} %{major}

%define	libasm	%mklibname asm %{major}
%define libdw	%mklibname dw %{major}
%define	libelf	%mklibname elf %{major}
%define	devname	%mklibname %{name} -d
%define	static	%mklibname %{name} -d -s

%define _program_prefix eu-

Summary:	A collection of utilities and DSOs to handle compiled objects
Name:		elfutils
Version:	0.155
Release:	1
License:	GPLv2+
Group:		Development/Other
Url:		http://fedorahosted.org/elfutils/
Source0:	http://fedorahosted.org/releases/e/l/elfutils/%{name}-%{version}.tar.bz2
Source1:	%{SOURCE0}.sig
# these 2 patches are from ftp://sources.redhat.com/pub/systemtap/elfutils/ 
# this hasn't been used since 200700 import why keep around
#Patch0:		elfutils-portability.patch
Patch1:		elfutils-robustify.patch
Patch2:		elfutils-0.155-binutils-pr-ld-13621.patch

# mdv patches
Patch10:	elfutils-0.153-mips_backend.patch
Patch11:	elfutils-0.139-sparc-align.patch
Patch12:	elfutils-0.139-fix-special-sparc-elf32-plt-entries.patch
Patch13:	elfutils-0.152-strip-.GCC.command.line-section.patch
Patch14:	elfutils-0.153-add-missing-lpthread-linkage.patch
Patch15:	elfutils_signed_comparison.patch
Patch17:	elfutils-0.153-dont-fail-on-strip-reloc-check-against-self.patch

BuildRequires:	bison
BuildRequires:	flex
BuildRequires:	glibc-devel
BuildRequires:	zlib-devel
BuildRequires:	bzip2-devel
BuildRequires:	lzma-devel
BuildRequires:	gettext-devel
Obsoletes:	%{libname}

%description
Elfutils is a collection of utilities, including ld (a linker),
nm (for listing symbols from object files), size (for listing the
section sizes of an object or archive file), strip (for discarding
symbols), readelf (to see the raw ELF file structures), and elflint
(to check for well-formed ELF files).

%package -n	%{libasm}
Summary:	Libraries to read and write ELF files
Group:		System/Libraries
Obsoletes:	%{libname}

%description -n	%{libasm}
Included are the helper library which implement machine-specific ELF handling.

%package -n	%{libdw}
Summary:	Libraries to read and write ELF files
Group:		System/Libraries
Obsoletes:	%{libname}

%description -n	%{libdw}
Included are the helper library which implement DWARF ELF handling.

%package -n	%{libelf}
Summary:	Libraries to read and write ELF files
Group:		System/Libraries
Obsoletes:	%{libname}

%description -n	%{libelf}
This package provides DSOs which allow reading and writing ELF files
on a high level.  Third party programs depend on this package to read
internals of ELF files.  The programs of the elfutils package use it
also to generate new ELF files.

%package -n	%{devname}
Summary:	Development libraries to handle compiled objects
Group:		Development/Other
Requires:	%{libasm} = %{EVRD}
Requires:	%{libdw} = %{EVRD}
Requires:	%{libelf} = %{EVRD}
Provides:	%{name}-devel

%description -n	%{devname}
This package contains the headers and dynamic libraries to create
applications for handling compiled objects.

   * libelf allows you to access the internals of the ELF object file
     format, so you can see the different sections of an ELF file.
   * libebl provides some higher-level ELF access functionality.
   * libasm provides a programmable assembler interface.

%package -n	%{static}
Summary:	Static libraries for development with libelfutils
Group:		Development/Other
Requires:	%{devname} = %{EVRD}
Provides:	%{name}-static-devel

%description -n	%{static}
This package contains the static libraries to create applications for
handling compiled objects.

%prep
%setup -q
%apply_patches

%build
mkdir build-%{_target_platform}
pushd build-%{_target_platform}

# [pixel] libld_elf_i386.so is quite weird, could be dropped? workarounding for now...
%define _disable_ld_no_undefined 1

CFLAGS="%{optflags} -Wno-error" \
CONFIGURE_TOP=.. \
%configure2_5x \
	%{?_program_prefix: --program-prefix=%{_program_prefix}} \
	--enable-thread-safety \
	--with-zlib \
	--with-bzlib \
	--with-lzma

%make
popd

%check
pushd build-%{_target_platform}
make check || true
popd

%install
%makeinstall_std -C build-%{_target_platform}

%find_lang %{name}

%files -f %{name}.lang
%doc NOTES README NEWS TODO
%{_bindir}/eu-*
%dir %{_libdir}/elfutils
%{_libdir}/elfutils/lib*.so

%files -n %{libelf}
%{_libdir}/libelf-%{version}.so
%{_libdir}/libelf*.so.%{major}*

%files -n %{libdw}
%{_libdir}/libdw-%{version}.so
%{_libdir}/libdw*.so.%{major}*

%files -n %{libasm}
%{_libdir}/libasm-%{version}.so
%{_libdir}/libasm*.so.%{major}*

%files -n %{devname}
%{_includedir}/dwarf.h
%{_includedir}/libelf.h
%{_includedir}/gelf.h
%{_includedir}/nlist.h
%dir %{_includedir}/elfutils
%{_includedir}/elfutils/*.h
%{_libdir}/libelf.so
%{_libdir}/libdw.so
%{_libdir}/libasm.so

%files -n %{static}
%{_libdir}/*.a


%changelog
* Wed Oct 31 2012 Per Øyvind Karlsen <peroyvind@mandriva.org> 0.155-1
+ Revision: 821443
- don't manually give liraries executable permissions for them to get stripped,
  this is nos properly handled by spec-helper scripts
- ignore tests failing for now, just get a work version of elfutils pushed
- add elfutils-0.155-binutils-pr-ld-13621.patch (P2, from Fedora)

  + Tomasz Pawel Gajc <tpg@mandriva.org>
    - disable patch 16
    - rediff patch 10
    - update to new version 0.155

* Tue Aug 07 2012 Tomasz Pawel Gajc <tpg@mandriva.org> 0.154-2
+ Revision: 812216
- last release somehow never reached mirrors, so reaupload it

* Wed Jun 27 2012 Alexander Khrukin <akhrukin@mandriva.org> 0.154-1
+ Revision: 807188
- version update 0.154
- version update 0.153

* Sat Mar 10 2012 Per Øyvind Karlsen <peroyvind@mandriva.org> 0.153-1
+ Revision: 783808
- don't fail if strip-reloc test against self doesn't pass (P17)
- fix broken check in mips backend patch
- run elflint test but don't make it fail on arm/mips (mga)
- fix some signed vs unsigned comparisons (appears only on some arches, mga)
- rediff mips_backend patch (back to a "normal" 40-50k size instead of 600k, mga)
- add missing linkage against libpthread
- drop no longer necessary use of autoconf
- rebuild with internal dependency generator

  + Tomasz Pawel Gajc <tpg@mandriva.org>
    - do use make macro in check section
    - update to new version 0.153
    - drop patch 14, applied by upstream

* Wed Dec 21 2011 Matthew Dawkins <mattydaw@mandriva.org> 0.152-5
+ Revision: 744063
- use major for all the libs
- fixed files name for libelf
- rebuild
- split out individual libs
- moved plugins back to utils pkg
- removed old obsolotes, provides
- removed old compat build (never used since 200700)
- employeed apply_patches

* Tue Nov 29 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 0.152-4
+ Revision: 735316
- use %%{EVRD} macro
- remove a couple of bogus provides/requires
- backport --reloc-debug-sections from git (P14)

* Sat Apr 16 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 0.152-3
+ Revision: 653857
- require check suite to pass
- just disable -Werror with -Wno-error in stead
- place all libraries in the corresponding lib/-devel package
- package eu-ld

* Wed Mar 30 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 0.152-2
+ Revision: 649314
- clean up a bit further..
- remove obsolete stuff
- strip away ".GCC.command.line" section when stripping away debug sections (P13)

* Sat Mar 12 2011 Tomasz Pawel Gajc <tpg@mandriva.org> 0.152-1
+ Revision: 644016
- update to new version 0.152

* Sat Nov 27 2010 Tomasz Pawel Gajc <tpg@mandriva.org> 0.150-1mdv2011.0
+ Revision: 601940
- update to new version 0.150

* Sat Nov 27 2010 Funda Wang <fwang@mandriva.org> 0.149-2mdv2011.0
+ Revision: 601638
- rebuild for py liblzma

* Thu Sep 16 2010 Tomasz Pawel Gajc <tpg@mandriva.org> 0.149-1mdv2011.0
+ Revision: 579048
- update to new version 0.149

* Sun Jul 11 2010 Tomasz Pawel Gajc <tpg@mandriva.org> 0.148-1mdv2011.0
+ Revision: 551017
- update to new version 0.148

* Wed Apr 28 2010 Emmanuel Andry <eandry@mandriva.org> 0.146-1mdv2010.1
+ Revision: 540498
- New version 0.146
- update p0 and p1
- BR gettext-devel
- update files list

* Sat Apr 03 2010 Tomasz Pawel Gajc <tpg@mandriva.org> 0.145-1mdv2010.1
+ Revision: 530871
- update to new version 0.145
- rediff patch 10

* Mon Feb 01 2010 Tomasz Pawel Gajc <tpg@mandriva.org> 0.144-1mdv2010.1
+ Revision: 499243
- update to new version 0.144

* Wed Sep 23 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 0.143-1mdv2010.0
+ Revision: 448079
- enable support for lzma
- update to new version 0.143
- update robustify and portability patches

* Sat Aug 01 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 0.142-1mdv2010.0
+ Revision: 407145
- update portability and robustify patches
- adapt mips patch to the latest elfutils changes
- update to new version 0.142

* Sat May 02 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 0.141-1mdv2010.0
+ Revision: 370677
- update to new version 0.141

* Fri Feb 20 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 0.140-1mdv2009.1
+ Revision: 343294
- update patch 0 and 1

  + Per Øyvind Karlsen <peroyvind@mandriva.org>
    - new release: 0.140
    - add back sparc patches which were previously dropped due to laziness by others:/
    - add mips backend (P10 from 2008.1 Gdium tree)

* Sat Jan 24 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 0.139-1mdv2009.1
+ Revision: 333340
- enable thread safety (TLS)
- add buildrequires on zlib-devel and bzip2-devel, since libdwfl can auto-decompress ELF files
- Patch 0 and 1: update to 0.139
- drop patch2, merged upstream
- update to new version 0.139

* Sat Jan 03 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 0.138-1mdv2009.1
+ Revision: 323566
- Patch1: new version
- Patch2: fix regression introduced in elfutils-0.138
- better description
- update to new version 0.138

* Mon Dec 29 2008 Oden Eriksson <oeriksson@mandriva.com> 0.137-2mdv2009.1
+ Revision: 321096
- rebuild

* Wed Sep 03 2008 Tomasz Pawel Gajc <tpg@mandriva.org> 0.137-1mdv2009.0
+ Revision: 279399
- Patch 0 and 1: new versions
- obsolete older versions than 0.137
- run autoreconf, needed by portability patch
- drop additional tests, sources 2 and 3
- update to new version 0.137
- add sig file
- reorder sources

* Wed Aug 06 2008 Thierry Vignaud <tv@mandriva.org> 0.135-2mdv2009.0
+ Revision: 264438
- rebuild early 2009.0 package (before pixel changes)

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers
    - set %%_disable_ld_no_undefined (needed by libld_elf_i386.so) instead of messing LDFLAGS

* Sun May 25 2008 Tomasz Pawel Gajc <tpg@mandriva.org> 0.135-1mdv2009.0
+ Revision: 211246
- update to new version 0.135
- drop all patches excluding patch 0 and 1
- re-define LDFLAGS
- package libasm
- package eu-objdump program
- fix file list

* Sun Feb 10 2008 Tomasz Pawel Gajc <tpg@mandriva.org> 0.131-2mdv2008.1
+ Revision: 164990
- rebuild

* Sun Dec 30 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 0.131-1mdv2008.1
+ Revision: 139413
- add two test files (Source 1 and 2)
- provide updated version of patch 6  (gnu_inline)
- fix mem leak with patch 9
- provide patches 10 and 11 (minor upstream fixes)
- patch 8 has been merged upstream
- drop useles buildrequires on sharutils and libtool-devel (?)
- add buildrequires on bison and flex
- new program: eu-make-debug-archive
- spec file clean
- correct Source0
- new version 0.131
- update upstream patches 0,1,2

  + Olivier Blin <blino@mandriva.org>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Sat Jul 14 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 0.128-1mdv2008.0
+ Revision: 52067
- new program: eu-strip
- remove dead entries in spec file
- correct libification
- correct patch order
- provide patch 6 (gnu_inline)
- provide patches 7 and 8 (minor fixes)
- new version 0.128

* Thu Jun 21 2007 Olivier Thauvin <nanardon@mandriva.org> 2mdv2008.0-current
+ Revision: 42294
- don't redefine _gnu to nil
- apply new devel policy

* Fri Jun 08 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 0.127-1mdv2008.0
+ Revision: 37513
- Updated to version 0.127.
- Added updated upstream versions of patches portability and robustify
  (fedora).

* Thu May 03 2007 Per Øyvind Karlsen <peroyvind@mandriva.org> 0.126-1mdv2008.0
+ Revision: 20819
- new release: 0.126
- sync patches with fedora


* Sat Jan 27 2007 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.125-2mdv2007.0
+ Revision: 114272
- elfutils should now work on sparc! :)
- support special case of SPARC ELF32 PLT entires (P6 from PLD)
- allocated pointers need 8-byte alignment on sparc (to use ldd/std opcodes to access 8-byte aligned structs) (P5 from PLD)

* Thu Jan 25 2007 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.125-1mdv2007.1
+ Revision: 113565
- check fails on other archs than sparc too, enable it for all but make failure non-fatal
- reenable check (except for sparc)
- new release: 0.125
- Fix overeager warn_unused_result build failures. (P3 from fedora)
- eu-strip -f: copy symtab into debuginfo file when relocs use it (P4 from fedora, RHBZ #203000)

* Tue Oct 31 2006 Oden Eriksson <oeriksson@mandriva.com> 0.120-3mdv2007.1
+ Revision: 74664
- bunzip patches
- Import elfutils

* Mon May 15 2006 Stefan van der Eijk <stefan@eijk.nu> 0.120-2mdk
- rebuild for sparc

* Wed Apr 19 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.120-1mdk
- 0.120
- update robustification patch (P1)
- fix sparc build (P2)
- License has been changed to GPL, except for libraries which is still OSL
- move check to %%check stage
- disable checks on sparc

* Thu Apr 06 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.119-2mdk
- add robustification patch (P1) from fedora
- don't give errors on compile warnings on sparc

* Fri Jan 27 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.119-1mdk
- 0.119
- %%mkrel

* Wed Dec 28 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.118-1mdk
- 0.118

* Wed Jul 27 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.109-1mdk
- 0.109

* Thu Feb 17 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.99-1mdk
- 0.99

* Sun Jan 23 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.97-1mdk
- 0.97
- fix summary-ended-with-dot

* Sat Sep 18 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.96-1mdk
- 0.96

